carrito/urls.py
from django.urls import path
from . import views

app_name = 'carrito'

urlpatterns = [
    path('', views.detalle_carrito, name='detalle_carrito'),
    path('add/<obra_id>/', views.agregar_obra_carrito, name='agregar_obra_carrito'),
    path('remove/<obra_id>/', views.eliminar_obra_carrito, name='eliminar_obra_carrito'),
]

symbiarts/urls.py
from django.contrib import admin
from django.urls import path, include
from django.contrib.auth import views as auth_views
from cuentas import views as cuentas_views
from django.conf.urls import url
from . import settings
from django.contrib.staticfiles.urls import static
from django.contrib.staticfiles.urls import staticfiles_urlpatterns


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('symbiarts_app.urls')),
    path('carrito/', include('carrito.urls')),
    path('signup/', cuentas_views.signup, name='signup'),
    path('login/', auth_views.LoginView.as_view(
         template_name='login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(
         next_page='/'), name='logout'),
    path('mi_cuenta/', cuentas_views.UserUpdateView.as_view(),
         name='my_account'),

    url(r'^reset/$',
        auth_views.PasswordResetView.as_view(
            template_name='password_reset.html',
            email_template_name='password_reset_email.html',
            subject_template_name='password_reset_subject.txt'
        ),
        name='password_reset'),
    url(r'^reset/done/$',
        auth_views.PasswordResetDoneView.as_view(
            template_name='password_reset_done.html'),
        name='password_reset_done'),
    url(r'^reset/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$',
        auth_views.PasswordResetConfirmView.as_view(
            template_name='password_reset_confirm.html'),
        name='password_reset_confirm'),
    url(r'^reset/complete/$',
        auth_views.PasswordResetCompleteView.as_view(
            template_name='password_reset_complete.html'),
        name='password_reset_complete'),

    path('cambiar_password/', auth_views.PasswordChangeView.as_view(
        template_name='password_change.html'),
        name='cambiar_password'),
    path('cambiar_password/exitosa/',
         auth_views.PasswordChangeDoneView.as_view(
            template_name='password_change_done.html'),
         name='password_change_done'),
]

urlpatterns += staticfiles_urlpatterns()
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

symbiarts_app/urls.py
from django.urls import path

from . import views

app_name = 'symbiarts_app'
urlpatterns = [
    path('', views.lista_obras, name='lista_obras'),
    path('buscar/', views.buscar_obras, name='buscar_obras'),
    path('categoria/<str:nombre_categoria>', views.lista_obras_categoria,
         name='lista_obras_categoria'),
    path('obra/<int:obra_id>/compra/', views.orquestar_compra_carrito,
         name='orquestar_compra_carrito'),
    path('obra/<int:obra_id>/compra/confirmar', views.grabar_compra,
         name='grabar_compra'),
    path('compra_exitosa/<int:nro_compra>',
         views.compra_exitosa, name='compra_exitosa'),
    path('carrito/comprar', views.comprar_carrito, name='comprar_carrito'),
    path('carrito/comprar/confirmar', views.grabar_compra_carrito,
         name='grabar_compra_carrito'),
    path('obra/<int:pk>/editar/', views.editar_obra, name='editar_obra'),
    path('obra/<int:pk>/', views.detalle_obra, name='detalle_obra'),
    path('obra/nueva', views.nueva_obra, name='nueva_obra'),
    path('obra/<int:pk>/pausar/', views.pausar_obra, name='pausar_obra'),
    path('obra/<int:pk>/activar/', views.activar_obra,
         name='activar_obra'),
    path('obra/<int:pk>/comentar/', views.nuevo_comentario,
         name='nuevo_comentario'),
    path('compras/', views.lista_compras, name='lista_compras'),
    path('compra/<int:compra_id>/', views.detalle_compra,
         name='detalle_compra'),
    path('ventas/', views.lista_ventas, name='lista_ventas'),
    path('venta/<int:venta_id>/', views.detalle_venta,
         name='detalle_venta'),
    path('comentario/<int:pk>/eliminar/', views.eliminar_comentario,
         name='eliminar_comentario'),
    path('mis_obras/', views.mis_obras, name='mis_obras'),
]

carrito/models.py
from django.db import models

# Create your models here.

carrito/forms.py
from django import forms


class FormAgregarObraCarrito(forms.Form):
    def __init__(self, *args, **kwargs):
        stock = kwargs.pop('stock')
        lista_stock = [(i, str(i)) for i in range(1, stock+1)]
        super(FormAgregarObraCarrito, self).__init__(*args, **kwargs)
        self.fields['cantidad'] = forms.TypedChoiceField(
            choices=lista_stock, coerce=int)

    cantidad = forms.TypedChoiceField()

    actualizar_cantidad = forms.BooleanField(
        required=False, initial=False, widget=forms.HiddenInput)

    accion = forms.CharField(widget=forms.HiddenInput, required=False)

carrito/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.views.decorators.http import require_POST
from symbiarts_app.models import Obra
from symbiarts_app.forms import FormBuscar
from .carrito import Carrito
from .forms import FormAgregarObraCarrito


@require_POST
def agregar_obra_carrito(request, obra_id):
    carrito = Carrito(request)
    obra = get_object_or_404(Obra, id=obra_id)

    if request.user == obra.artista:
        mensaje = ("no puede agregar al carrito esta obra porque le pertenece"
                   " a usted mismo!.")
        return render(request, 'symbiarts_app/error_generico.html', {
            'mensaje': mensaje})

    if obra.tipo == 'AW':
        mensaje = ("no puede agregar al carrito esta obra porque es de tipo"
                   " ArtWork.")
        return render(request, 'symbiarts_app/error_generico.html', {
            'mensaje': mensaje})

    if obra.pausada:
        mensaje = ("no puede agregar al carrito esta obra porque esta "
                   "pausada.")
        return render(request, 'symbiarts_app/error_generico.html', {
            'mensaje': mensaje})

    form = FormAgregarObraCarrito(request.POST,
                                  stock=obra.obtener_stock())
    if form.is_valid():
        cd = form.cleaned_data
        carrito.agregar_obra(
            obra=obra,
            cantidad=cd['cantidad'],
            actualizar_cantidad=cd['actualizar_cantidad']
            )
    return redirect('carrito:detalle_carrito')


def eliminar_obra_carrito(request, obra_id):
    carrito = Carrito(request)
    obra = get_object_or_404(Obra, id=obra_id)
    carrito.eliminar_obra(obra)
    return redirect('carrito:detalle_carrito')


def detalle_carrito(request):
    carrito = Carrito(request)
    for item in carrito:
        stock = item['obra'].stock
        formAgregarObraCarrito = FormAgregarObraCarrito(
            stock=stock)
        formAgregarObraCarrito.fields['cantidad'].initial = item['cantidad']
        formAgregarObraCarrito.fields['actualizar_cantidad'].initial = True
        item['form_agregar_obra_carrito'] = formAgregarObraCarrito
    formBuscar = FormBuscar()
    return render(request, 'carrito/detalle_carrito.html', {
        'carrito': carrito,
        'formBuscar': formBuscar})

carrito/templates/carrito/detalle_carrito.html
{% extends 'symbiarts_app/base.html' %}
{% load static %}

{% block title %}Carrito de compras{% endblock %}

{% block navbar %}
    {% include 'symbiarts_app/navbar.html' %}
{% endblock %}

{% load bootstrap4 %}
{% bootstrap_javascript jquery='full' %}

{% block content %}
    <div class="mt-3">
        {% with totail_items=carrito|length %}
            {% if carrito|length > 0 %}
                <div class="row">
                    <h2 class="text-white">Carrito de compras</h2>
                </div>
            {% else %}
                <div class="jumbotron text-xs-center">
                    <h1 class="display-4">Tu carrito esta vacío.</h1>
                    <hr>
                    <a href="{% url 'symbiarts_app:lista_obras' %}" class="btn btn-primary"><i class="fas fa-store"></i> Comprá alguna obra</a>
                </div>
            {% endif %}
        {% endwith %}
        {% if carrito|length > 0 %}
            <div class="row mt-2">
                <table class="tabla-carrito table table-secondary table-hover">
                    <thead>
                        <tr>
                            <th>Obra</th>
                            <th>Descripción</th>
                            <th>Cantidad</th>
                            <th>Precio unitario</th>
                            <th>Subtotal</th>
                            <th>Acciones</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for item in carrito %}
                            {% with obra=item.obra  %}
                                <tr>
                                    <td>
                                        <a href="{% url 'symbiarts_app:detalle_obra' pk=obra.pk %}">
                                            {% with archivo_obra=obra.archivos.first %}
                                                {% if archivo_obra.archivo.url %}
                                                    <img src="{{ archivo_obra.archivo.url }}" alt="{{ obra.nombre }}" class="img-fluid" style="height: 90px; width: auto">
                                                {% else %}
                                                    <img src="{% static 'img/default.svg' %}" class="img-fluid" alt="{{ obra.nombre }}" style="height: 90px; width: auto">
                                                {% endif %}
                                            {% endwith %}
                                        </a>
                                    </td>
                                    <td class="align-middle">{{ obra.nombre }}</td>
                                    <td class="align-middle">
                                        <form class="form-inline" action="{% url 'carrito:agregar_obra_carrito' obra.id %}" method="post">
                                            {% csrf_token %}
                                            {% bootstrap_messages %}
                                            {% bootstrap_form_errors item.form_agregar_obra_carrito %}
                                            {% bootstrap_field item.form_agregar_obra_carrito.cantidad show_label=False %}
                                            {% bootstrap_field item.form_agregar_obra_carrito.actualizar_cantidad %}
                                            <button type="submit" class="btn btn-info ml-1"><i class="fas fa-sync-alt"></i></button>
                                        </form>
                                    </td>
                                    <td class="align-middle">${{ item.precio }}</td>
                                    <td class="align-middle">${{ item.precio_total }}</td>
                                    <td class="align-middle">
                                        <a href="{% url 'carrito:eliminar_obra_carrito' obra.id %}" class="btn btn-danger ml-1"><i class="far fa-trash-alt"></i></a>
                                    </td>
                                </tr>
                            {% endwith %}
                        {% endfor %}
                    </tbody>
                    <tfoot>
                        <tr>
                            <td><b>Total</b></td>
                            <td colspan="3"></td>
                            <td colspan="num"><b>${{ carrito.obtener_precio_total }}</b></td>
                            <td><a href="{% url 'symbiarts_app:comprar_carrito' %}" class="btn btn-success"><i class="fas fa-dollar-sign"></i> Comprar</a></td>
                        </tr>
                    </tfoot>
                </table>
                <div class="form-group">
                    <a href="{% url 'symbiarts_app:lista_obras' %}" class="btn btn-primary"><i class="fas fa-store"></i> Seguir comprando</a>
                </div>
            </div>
        {% endif %}
    </div>
{% endblock %}